import pkgutil
import io

__all__ = ['get_data_file']

def get_data_file(pkg, path):
    """Returns a file object for a package data file.
    
    Parameters
    ----------
    pkg : str
        dotted package hierarchy. e.g. "pymc3.examples"
    path : str 
        file path within package. e.g. "data/wells.dat"
    Returns 
    -------
    BytesIO of the data
    """

    return io.BytesIO(pkgutil.get_data(pkg, path))

